// https://eslint.org/docs/user-guide/configuring

module.exports = {
  root: true,
  parserOptions: {
    parser: 'babel-eslint',
  },
  env: {
    browser: true,
  },
  extends: [
    // https://github.com/vuejs/eslint-plugin-vue#priority-a-essential-error-prevention
    // consider switching to `plugin:vue/strongly-recommended` or `plugin:vue/recommended` for stricter rules.
    'plugin:vue/essential',
    // https://github.com/standard/standard/blob/master/docs/RULES-en.md
    'standard',
  ],
  globals: {
    $: true,
  },
  // required to lint *.vue files
  plugins: ['vue', 'html', 'flowtype-errors'],
  // add your custom rules here
  rules: {
    'flowtype-errors/show-errors': 2,
    // allow async-await
    'generator-star-spacing': 'off',
    // allow debugger during development
    'no-debugger': process.env.NODE_ENV === 'production' ? 'error' : 'off',
    'no-useless-escape': 'off',
    'no-tabs': 'off',
    'no-mixed-spaces-and-tabs': 0,
    'comma-dangle': 0,
    'space-before-function-paren': [0, 'always'],
  },
}
